"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GridCol = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_unistyles_1 = require("react-native-unistyles");
const context_1 = require("@procyon/components/Grid/context");
const types_1 = require("../types");
const GridCol = ({ cols = { [types_1.sm]: 1 }, children, style }) => {
    const grid = (0, react_1.useContext)(context_1.GridContext);
    const { styles } = (0, react_native_unistyles_1.useStyles)(stylesheet);
    return (react_1.default.createElement(react_native_1.View, { "aria-label": 'grid-col', style: [
            styles.procyon_gridCol_container({
                cols,
                gridCols: grid.cols,
            }),
            style,
        ] }, children));
};
exports.GridCol = GridCol;
const stylesheet = (0, react_native_unistyles_1.createStyleSheet)({
    procyon_gridCol_container: ({ cols, gridCols }) => {
        const getSize = (size, source) => {
            var _a, _b, _c, _d, _e, _f;
            switch (size) {
                case types_1.GridSizeEnum.xl:
                    return (_c = (_b = (_a = source['xl']) !== null && _a !== void 0 ? _a : source['lg']) !== null && _b !== void 0 ? _b : source['md']) !== null && _c !== void 0 ? _c : source['sm'];
                case types_1.GridSizeEnum.lg:
                    return (_e = (_d = source['lg']) !== null && _d !== void 0 ? _d : source['md']) !== null && _e !== void 0 ? _e : source['sm'];
                case types_1.GridSizeEnum.md:
                    return (_f = source['md']) !== null && _f !== void 0 ? _f : source['sm'];
                case types_1.GridSizeEnum.sm:
                    return source['sm'];
            }
        };
        return {
            padding: 2,
            flex: {
                xl: (100 / getSize(types_1.xl, gridCols)) * getSize(types_1.xl, cols),
                lg: (100 / getSize(types_1.lg, gridCols)) * getSize(types_1.lg, cols),
                md: (100 / getSize(types_1.md, gridCols)) * getSize(types_1.md, cols),
                sm: (100 / getSize(types_1.sm, gridCols)) * getSize(types_1.sm, cols),
                xs: '100%',
            },
        };
    },
});
