"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectboxModal = void 0;
const react_1 = __importDefault(require("react"));
const ramda_1 = require("ramda");
const react_native_unistyles_1 = require("react-native-unistyles");
const Trash_1 = require("@procyon/components/Icons/Trash");
const List_1 = require("@procyon/components/List");
const enums_1 = require("@procyon/types/enums");
const Button_1 = require("../../Button");
const SelectboxModal = (props) => {
    var _a;
    const { options, autoComplete, selectedId, onChange, onRemove, closeModal } = props;
    const { theme } = (0, react_native_unistyles_1.useStyles)();
    const handleChange = (id) => {
        onChange(id);
        closeModal();
    };
    const removeActiveOption = () => {
        onRemove();
        closeModal();
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(List_1.List, { options: options, autoComplete: autoComplete, selectedId: selectedId, onClick: handleChange, style: (0, ramda_1.mergeDeepRight)({
                container: {
                    maxHeight: 250,
                    marginVertical: 10,
                },
                section: {
                    message: {
                        fontSize: theme.fontSize.sm,
                    },
                },
            }, (_a = props.style) !== null && _a !== void 0 ? _a : {}) }),
        props.clearable && (react_1.default.createElement(Button_1.Button, { label: react_1.default.createElement(Trash_1.TrashIcon, { fontSize: 20 }), size: enums_1.SizeEnum.sm, status: enums_1.StatusEnum.warning, onClick: removeActiveOption, blank: true }))));
};
exports.SelectboxModal = SelectboxModal;
